//AHC - Nstroj pro kompresi pomoc Adaptivnho Huffmanova kdu
//vygenerovan kd nesm obsahovat ladc informace (po kompilaci pout TDSTRIP)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <io.h>
#include <dir.h>
#include <dos.h>
#include "bitio.h"

#pragma warn -pia //disable possibly incorrect assignment
#pragma option -K //unsigned char
#define PARAM_CHAR '/'
#define EXCLUDE_CHAR '!'
#define PATH_DIVIDER '\\'
#define MAX_FILENAME 255
#define MESSAGE_EVERY 10000
#define NPPVSS "Nedostatek pamti pro vytvoen seznamu soubor"

int scr_write; //indiktor vpisu na obrazovku

typedef char FNAME[MAX_FILENAME];
typedef struct _FILES {
	char *name;
	struct _FILES *next;
} FILES; //struktura pro uloen vce nzv soubor

typedef struct {
	FNAME fname;
	long fsize;
	unsigned fdate;
	unsigned ftime;
	unsigned fattr;
} FINFO;

typedef struct {
	unsigned attrib : 1;
	unsigned absnames : 1;
	unsigned erase : 1;
	unsigned extract : 1;
	unsigned onlynames : 1;
	unsigned pathnames : 1;
	unsigned recurse : 1;
	unsigned sfx : 1;
	unsigned std_in : 1;
	unsigned std_out : 1;
}	PARAM;

typedef int INDEX[258]; //tabulka znak pro rychl pstup do stromu

typedef struct {
	long count; //poet vskyt prvku
	int ch; //index pravho syna, lev = prav + 1, nekladn hodnoty = znak v listu
	int parent; //index rodie
} TREE[515]; //(256 znak + EOF + ESC) * 2 - 1

INDEX index; //0 = prvek ve strom nen
TREE tree; //uzly jsou slovn shora a zprava, 0 = koen, 1 = prav syn koene, 2 = lev syn koene, ...
int lastnode; //posledn zaplnn uzel ve strom
//globln struktury jsou rychlej ne pedvn promnnch



void error(int code, char *message) { if (scr_write) fprintf((scr_write == 1) ? stderr : stdout, "\nKritick chyba: %s\n", message); exit(code); }

int printaf(char *action, char *filename) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, "%-10s %-*s", action, 14 + 7 * (strlen(filename) / 7 - (strlen(filename) >= 7)), filename) : 0; }
int printdf(char *action, int counter) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, "\n%s%s %d %s\n", action, (counter == 1) ? "" : (counter > 1 && counter < 5) ? "y" : "o", counter, (counter == 1) ? "soubor" : (counter > 1 && counter < 5) ? "soubory" : "soubor") : 0; }
int printef(char *str) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, str) : 0; }
int printnf(char *str) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, "%s\n", str) : 0; }
int printpf(float percent) { int x; int result = 0; if (scr_write) { x = wherex(); result = cprintf("%5.1f%%", 100 * percent); gotoxy(x, wherey()); } return result; }
//funkce pro jednotnou podobu vpis, tisk se provede podle nastaven promnn scr_write




void init_tree(void) {
	int i;

	for (i=0; i<256; i++) index[i] = 0;
	index[256] = 2; //EOF
	index[257] = 1; //ESC
	tree[0].count = 2; tree[0].ch = 1; tree[0].parent = -1; //koen
	tree[1].count = 100; tree[1].ch = -257; tree[1].parent = 0; //ESC
	tree[2].count = 1; tree[2].ch = -256; tree[2].parent = 0; //EOF
	lastnode = 2;
}

void update_tree(int ch) {
	int i, temp;
	int node = index[ch];

	if (!node) { //nov znak
		index[ch] = lastnode + 1;
		index[-tree[lastnode].ch] += 2;
		tree[lastnode+2].count = tree[lastnode].count;
		tree[lastnode+2].ch = tree[lastnode].ch;
		tree[lastnode+2].parent = lastnode;
		tree[lastnode+1].count = 1;
		tree[lastnode+1].ch = -ch;
		tree[lastnode+1].parent = lastnode;
		tree[lastnode].ch = lastnode+1;
		node = lastnode;
		lastnode += 2;
	}

	for ((void) 0; node; tree[node].count++, node = tree[node].parent) {
		if (tree[node].count == tree[node-1].count) {
			for (i=node-1; tree[node].count == tree[i-1].count; i--) ;
			if (tree[i].ch <= 0) index[-tree[i].ch] = node; //peindexovn i nebo zmna rodie
			else { tree[tree[i].ch].parent = node; tree[tree[i].ch+1].parent = node; }
			if (tree[node].ch <= 0) index[-tree[node].ch] = i; //peindexovn node nebo zmna rodie
			else { tree[tree[node].ch].parent = i; tree[tree[node].ch+1].parent = i; }
			temp = tree[node].ch; tree[node].ch = tree[i].ch; tree[i].ch = temp; //prohozen znak nebo dt
			node = i;
		}
	}
	tree[0].count++;
}




void compress(BITFILE *archive, FILE *file, long fsize) {
//oekv oteven archiv se zapsanou hlavikou a oteven soubor
	int i, ch;
	long written;
	char checksum;
	long apos = ftell(archive->file), bpos;
	BITS bits;
	long mask;

	init_tree();
	for (checksum=0, written=0; ; checksum ^= ch) {
		if (!(written++ % MESSAGE_EVERY)) printpf(fsize ? (float) written / fsize : 0.0);
		if ((ch = getc(file)) == EOF) i = index[256];
		else if (!(i = index[ch])) i = index[257];
		for (mask=1, bits.data=0, bits.count=0; i; i=tree[i].parent, bits.count++, mask<<=1)
			if (i&1) bits.data |= mask;
		putbits(bits.data, bits.count, archive);
		if (!index[ch]) putbits(ch, 8, archive);
		else if (ch == EOF) break;
		update_tree(ch);
	}

	putbits(checksum, 8, archive);
	putbuf(archive);
	bpos = ftell(archive->file);
	fseek(archive->file, apos - 4, SEEK_SET);
	putbits(bpos - apos, 32, archive);
	fseek(archive->file, 0, SEEK_END);
	printpf(fsize ? (float) (bpos - apos) / fsize : 0.0); //vpis kompresnho pomru
}

void extract(BITFILE *archive, FILE *file, int write_mode) {
//rozbalen souboru, oekv oteven archiv a vstupn soubor
	int i, ch;
	char checksum;
	long readed;
	long fsize; //dlka zapakovanch dat
	long apos;

	if ((fsize = getbits(32, archive)) > 0) if (write_mode) {
		init_tree();
		apos = ftell(archive->file);

		for (checksum=0, readed=0; ; checksum ^= ch) {
			if (!(readed++ % MESSAGE_EVERY)) printpf((float) (ftell(archive->file) - apos) / fsize);
			for (i=0; tree[i].ch > 0; ) //naten jednoho znaku
			#pragma warn -eff //code has no effect
				i = tree[i].ch + !_getb(archive);
			#pragma warn +eff
			ch = -tree[i].ch;
			if (ch == 257) ch = getbits(8, archive);
			else if (ch == 256) break; //EOF
			putc(ch, file);
			update_tree(ch);
		}

		if (getbits(8, archive) != checksum) error(4, "Nesprvn kontroln souet");
		clearbuf(archive);
	} else fseek(archive->file, fsize, SEEK_CUR);
}




char *strbcpy(char *dest, char *src1, char *src2) {
//dest = src1\src2
	if (src1[0]) {
		strcpy(dest, src1);
		if (src1[strlen(src1)-1] != PATH_DIVIDER)
			{ dest[strlen(dest)+1] = 0; dest[strlen(dest)] = PATH_DIVIDER; }
		strcat(dest, src2);
	} else strcpy(dest, src2);
	return dest;
}

int strcmpe(char *se, char *s) {
	int i, j, pose, pos;
	for (i=0; se[i] != '*'; i++) {
		if (!se[i] || !s[i]) return (!se[i] && !s[i]); //konec etzce
		if (se[i] != s[i] && se[i] != '?') return 0; //porovnn
	}
	for (j = i; se[i] || s[j]; ) {
		if (se [i] == '*') {
			while (se[i] == '*') i++;
			if (!se[i]) return 1; //konec etzce po hvzdice
			pose = i; pos = j;
		}
		if (se[i] && (se[i] == '?' || se[i] == s[j])) { i++; j++; }
		else {
			i = pose; j = pos+1;
			while (s[j] != se[i] && s[j] && se[i] != '?') j++;
			if (!s[j]) return 0;
			pos = j;
		}
	}
	return 1;
}

int overwrite(int *overwriting, char *filename) {
//obsluha pepisovn
	int over = -1;
	switch (*overwriting) {
		case 'V': over = 1; break;
		case 'D': printaf("Peskakuji", filename); printnf(""); over = 0; break;
		default:
			printaf("Nalezeno", filename);
			printef("Pepsat? [A,N,V,D,K,?] ");
			while(over == -1) {
				switch (toupper(getch())) {
					case 'A': printef("Ano"); over = 1; break;
					case 'N': printef("Ne"); over = 0; break;
					case 'V': printef("Vechny"); *overwriting = 'V'; over = 1; break;
					case 'D': printef("Dn"); *overwriting = 'D'; over = 0; break;
					case 'K': printef("Konec"); error(5, "Perueno uivatelem"); break;
					default: printef("\nAno, Ne, Vechny, Dn, Konec "); break;
				}
			}
			printnf("");
	}
	return over;
}




void write_header(FILE *file, FINFO finfo) {
	int i;
	for (i=0; finfo.fname[i]; i++) putc(finfo.fname[i], file);
	putc(0, file);
	putc(finfo.fattr % 256, file);
	putc(finfo.fdate / 256, file); putc(finfo.fdate % 256, file);
	putc(finfo.ftime / 256, file); putc(finfo.ftime % 256, file);
}

FILES *expand_mask(FNAME mask, FILES *firstfile, FILES *files, FNAME dirname, PARAM param) {
//masku files->name zamn za seznam odpovdajcch soubor, vrt ukazatel na posledn vyexpandovan soubor
//nepidv ji pidan soubory, nepidv vylouen soubory, je-li to douc, rekurzivn prochz podadrese
	int done;
	struct ffblk ffblk;
	FILES *f;
	FNAME sdirname, fname;
	int found;
	char *str, *str2;

	if (mask[strlen(mask)-1] == PATH_DIVIDER) mask[strlen(mask)-1] = 0;
	if (!strchr(mask, '?') && !strchr(mask, '*') && !findfirst(mask, &ffblk, FA_DIREC) && (ffblk.ff_attrib & FA_DIREC)) strbcpy(mask, mask, "*.*"); //jako parametr jsem zadal jmno adrese

	strcpy(sdirname, dirname);
	strncat(dirname, mask, (str = strrchr(mask, PATH_DIVIDER)) ? str - mask + 1 : 0);
	strcpy(mask, (str = strrchr(mask, PATH_DIVIDER)) ? str + 1 : mask); //pehozen adres z masky do dirname
	strbcpy(fname, dirname, mask);
	done = findfirst(fname, &ffblk, 0);
	if (done && !sdirname[0]) { printaf("Nenalezeno", strupr(fname)); printnf(""); }
	while (!done) {
		strcpy(fname + strlen(dirname), ffblk.ff_name); //zmna masky za skuten jmno souboru
		for (found = 0, f = firstfile; firstfile != files && !found && f != files; f = f->next) //prchod zatkem seznamu kvli duplicitm
			found = !strcmpi((param.onlynames && (str = strrchr(f->name, PATH_DIVIDER))) ? str + 1 : f->name, (param.onlynames && (str2 = strrchr(fname, PATH_DIVIDER))) ? str2 + 1 : fname);
		for ((void) 0; !found && f; f = f->next) //prchod koncem seznamu kvli vylouenm souborm
			found = (f->name[0] == EXCLUDE_CHAR && strcmpe(strupr(f->name) + 1, ffblk.ff_name));
		if (!found) {
			f = files->next;
			if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
			files = files->next;
			files->next = f;
			if (!(files->name = malloc(strlen(fname)+1))) error(2, NPPVSS);
			strcpy(files->name, fname);
		}
		done = findnext(&ffblk);
	}

	if (param.recurse) { //rekurzivn prchod podadres
		strbcpy(sdirname, dirname, "*.*");
		done = findfirst(sdirname, &ffblk, FA_DIREC);
		while (!done) {
			if ((ffblk.ff_attrib & FA_DIREC) && ffblk.ff_name[0] != '.') {
				strbcpy(sdirname + strlen(dirname), ffblk.ff_name, "");
				files = expand_mask(mask, firstfile, files, sdirname, param);
			}
			done = findnext(&ffblk);
		}
	}
	return files;
}

int compress_files(BITFILE *archive, FILES *firstfile, PARAM param) {
//vytvo jednoznan seznam soubor a vechny zapakuje
	FNAME mask;
	FILES *ffind, *files = firstfile, *fprev = firstfile;
	FILE *file;
	FNAME fname, curdir;
	FINFO finfo;
	int counter = 0;
	char *str;
	struct time atime; struct date adate;

	printnf("\n");
	if (!param.std_in) while (files) { //prochzen vech zpracovvanch soubor
		if ((param.absnames || param.pathnames) && files->name[0] != EXCLUDE_CHAR) //vytvoen absolutn cesty vetn nzvu disku
			if (strchr(files->name, ':')) strcpy(mask, files->name);
			else if (files->name[0] == PATH_DIVIDER) sprintf(mask, "%c:%s", 'A' + getdisk(), files->name);
			else {
				getcurdir(0, curdir);
				if (curdir[0]) { curdir[strlen(curdir)+1] = 0; curdir[strlen(curdir)] = PATH_DIVIDER; }
				sprintf(mask, "%c:%c%s%s", 'A' + getdisk(), PATH_DIVIDER, curdir, files->name);
			}
		else strcpy(mask, files->name);
		if (mask[0] == EXCLUDE_CHAR) //jestlie je to vyluovac soubor, pouze ho vymau
			if (files == firstfile) { firstfile = firstfile->next; free(files); files = fprev = firstfile; }
			else { fprev->next = files->next; free(files); files = fprev->next; }
		else { //nevyluovac soubor
			curdir[0] = 0;
			ffind = expand_mask(mask, firstfile, files, curdir, param); //doplnn seznamu
			if (files == firstfile) firstfile = firstfile->next;
			else fprev->next = files->next; //odstrann souboru s maskou
			if (ffind != files) fprev = ffind; //maska se rozila
			if (files == ffind) { files = ffind->next; free(ffind); fprev = files; }
			else { free(files); files = ffind->next; }
		}
	}

	for (files = firstfile; param.std_in || files; files = files->next) { //prochzen jednoznanho seznamu soubor
		if (param.std_in) {
			_streams[0] = *freopen("CON", "rb", stdin);
			file = stdin;
			strcpy(fname, "stdin.");
			getdate(&adate); finfo.fdate = (adate.da_year-1980) << 9 | adate.da_mon << 5 | adate.da_day;
			gettime(&atime); finfo.ftime = atime.ti_hour << 11 | atime.ti_min << 5 | atime.ti_sec >> 1;
			finfo.fattr = finfo.fsize = 0;
		} else {
			strcpy(fname, files->name); strupr(fname);
			if (strrchr(fname, '.') <= strrchr(fname, PATH_DIVIDER)) strcat(fname, "."); //u jmna chyb ppona
		}

		printaf("Pakuji", param.std_in ? "(stdin)" : (param.pathnames) ? fname + 2 : fname);
		if (!param.std_in && !(file = fopen(fname, "rb"))) printef("Nelze otevt");
		else {
			if (param.onlynames && (str = strrchr(fname, PATH_DIVIDER))) strcpy(finfo.fname, str + 1);
			else if (param.pathnames && (str = strchr(fname, ':'))) strcpy(finfo.fname, str + 1);
			else strcpy(finfo.fname, fname);
			_dos_getftime(fileno(file), &finfo.fdate, &finfo.ftime);
			_dos_getfileattr(fname, &finfo.fattr);
			fseek(file, 0, SEEK_END); finfo.fsize = ftell(file); fseek(file, 0, SEEK_SET);
			write_header(archive->file, finfo);
			putbits(param.std_out, 32, archive); //msto na uloen velikosti, kdy zapisuji na stdout, nemu se vracet (kvli zapsn skuten dlky dat), proto alespo zapu nenulovou dlku
			compress(archive, file, finfo.fsize);
			counter++;
			if (!param.std_in && fclose(file)) error(1, "Nelze zavt vstupn soubor");
			if (!param.std_in && param.erase && unlink(fname) && scr_write) { gotoxy(wherex()+8, wherey()); printef("Nelze smazat"); }
		}
		printnf("");
		if (param.std_in) break;
	}

	strcpy(fname, archive->name);
	if (bclose(archive)) error(1, "Nelze zavt archiv");
	printdf("Zapakovn", counter);
	if (!counter && !param.sfx && unlink(fname)) printef("Nelze smazat przdn archiv");
	return 0;
}





int read_header(FILE *file, FINFO *finfo) {
	int ch, i;
	for (i=0; (ch = getc(file)) > 0; i++) finfo->fname[i] = ch;
	finfo->fname[i] = 0;
	finfo->fattr = getc(file);
	finfo->fdate = 256 * getc(file) + getc(file);
	finfo->ftime = 256 * getc(file) + getc(file);
	return ch;
}

int extract_files(BITFILE *archive, FILES *firstfile, PARAM param) {
//prochz archiv a u kadho souboru se podle masky soubor rozhodne, zda rozbalit i peskoit
	int i;
	int done;
	FILE *file;
	FNAME fname, dname, extract_dir;
	FILES *files;
	FINFO finfo;
	struct ffblk ffblk;
	int over;
	int counter = 0;
	char *str;

	printnf("\n");
	over = scr_write ? 0 : 'V';

	strcpy(fname, firstfile->name);
	if (fname[strlen(fname)-1] == PATH_DIVIDER) { //jestlie je na konci jmna souboru oddlova cesty, chce uivatel rozbalit soubory do adrese
		for (i=0; str = strchr(fname + i, PATH_DIVIDER); i = str - fname + 1) { //vytvoen potebnch adres
			strncpy(dname, fname, str - fname); dname[str-fname] = 0;
			mkdir(dname);
		}
		if (firstfile->next->name) { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); }
		else { files = firstfile; firstfile = firstfile->next; free(files); }
		strcpy(extract_dir, fname);
	}
	else if (param.extract && !strchr(fname, '?') && !strchr(fname, '*') && !findfirst(fname, &ffblk, FA_DIREC) && (ffblk.ff_attrib & FA_DIREC)) { //zjistm, jestli jmno prvnho souboru neoznauje adres
		if (firstfile->next->name) { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); }
		else { files = firstfile; firstfile = firstfile->next; free(files); }
		strcpy(extract_dir, fname);
	} else extract_dir[0] = 0;

	for (i=0; i != EOF; i = ungetc(getc(archive->file), archive->file)) {
		if (read_header(archive->file, &finfo)) error(4, "Neiteln hlavika archivu");
		if (param.onlynames && (str = strrchr(finfo.fname, PATH_DIVIDER))) strcpy(fname, str+1); else strcpy(fname, finfo.fname);
		for (done = 0, files = firstfile; files; files = files->next) //projde seznam zpracovvanch soubor a rozhodne, zda zpracovat
			if (strcmpe(strupr(files->name), fname)) done = 1;
			else if (files->name[0] == EXCLUDE_CHAR && strcmpe(strupr(files->name + 1), fname)) done = 0;
		if (done && param.extract)
			if (param.std_out) { _streams[1] = *freopen("CON", "wb", stdout); file = stdout; }
			else {
				if (!strchr(fname, ':') && fname[0] != PATH_DIVIDER) { strbcpy(dname, extract_dir, fname); strcpy(fname, dname); }
				if (file = fopen(fname, "r")) { fclose(file); done = overwrite(&over, fname); }
				if (done) {
					for (i=0; str = strchr(fname + i, PATH_DIVIDER); i = str - fname + 1) { //vytvoen potebnch adres
						strncpy(dname, fname, str - fname); dname[str-fname] = 0;
						mkdir(dname);
					}
					strupr(fname);
					if (!(file = fopen(fname, "wb"))) { printaf("Nalezeno", fname); printnf("Nelze vytvoit"); done = 0; }
				}
			}
		if (done) printaf(param.extract ? "Rozbaluji" : "Nalezeno", fname);
		extract(archive, file, done && param.extract);

		if (!done) continue;
		if (param.extract) printpf(1.0);
		counter++; printnf("");
		if (!param.extract) continue;
		if (fclose(file)) error(1, "Nelze zavt vstupn soubor");
		if (!param.attrib) continue;
		if (!(file = fopen(fname, "r"))) error(1, "Nelze otet vstupn soubor");
		_dos_setftime(fileno(file), finfo.fdate, finfo.ftime);
		if (fclose(file)) error(1, "Nelze zavt vstupn soubor");
		_dos_setfileattr(fname, finfo.fattr);
	}

	printdf(param.extract ? "Rozbalen" : "Nalezen", counter);
	strcpy(fname, archive->name);
	if (!param.std_out && bclose(archive)) error(1, "Nelze zavt archiv");
	if (!param.std_out && param.erase && unlink(fname)) printnf("Nelze smazat archiv");

	return 0;
}





void help(int code) {
	struct text_info tinfo;

	gettextinfo(&tinfo);
	printnf("      Jakub Vrna, 1998, public domain, verze 1.0");
	printnf("\nPouit: AHC.EXE  pkaz  [pepnae]  [archiv]  [soubor, ...]");
	printnf("\nPkazy:");
	printnf("    a   Zapakovat do archivu");
	printnf("    l   Vypsat obsah archivu");
	printnf("    x   Rozpakovat z archivu");
	printnf("\nArchiv: Jmno souboru s archivem");
	printnf("Soubor: Jmno zpracovvanho souboru, !soubor - nezpracovvat");
	if (tinfo.screenheight < 30) { printef("\n(klvesu pro pokraovn)"); if (scr_write) getch(); printnf(""); }
	printnf("\nPepnae: kad parametr zanajc znakem / nebo -");
	printnf("   -a   Obnovit pvodn atributy, datum a as souboru");
	printnf("   -d   Ukldat absolutn adresov struktury vetn nzvu disku");
	printnf("   -e   Smazat zpracovan soubory");
	printnf("   -i   Vstup brt ze standardnho vstupu");
	printnf("   -l   Jmna soubor brt ze soubor na pkazov dce");
	printnf("   -m   Archiv rozpakovat do novho adrese");
	printnf("   -n   Ukldat pouze jmna soubor bez adresovch struktur");
	printnf("   -o   Vstup dvat na standardn vstup");
	printnf("   -p   Ukldat absolutn adresov struktury krom nzvu disku");
	printnf("   -r   Prochzet strukturu podadres");
	printnf("   -s   Nevypisovat dn hlen, neklst dn dotazy");
	printnf("   -x   Vytvoit samorozbaliteln archiv");
	printnf("   -z   Zprvy vypisovat na standardn vstup msto na chybov");
	exit(code);
}

long getexesize(FILE *file) {
	long exesize;
	long startpos = ftell(file);
	fseek(file, 2, SEEK_SET); exesize = getc(file)+getc(file)*256 + (long) 512 * (getc(file)+getc(file)*256);
	fseek(file, 8, SEEK_SET); exesize -= (long) 16 * getc(file)+getc(file)*256;
	fseek(file, startpos, SEEK_SET);
	return exesize;
}

int main(int argc, char *argv[]) {
	int i;
	long a;
	int done;
	char *str;
	char command = 0;
	FILE *file;
	FILES *files, *firstfile, *files_temp;
	FNAME archive_name, fname;
	BITFILE *archive;
	char switches[255];
	struct ffblk ffblk;
	PARAM param;
	long exesize;

	switches[0] = 0;
	if (!(files = malloc(sizeof(FILES)))) error(2, NPPVSS);
	files->next = NULL;
	files->name = NULL;
	firstfile = files;

	for (i=1; i < argc; i++) { //prchod pkazovou dkou
		if (argv[i][0] == '-' || argv[i][0] == PARAM_CHAR) strcat(switches, argv[i] + 1);
		else if (!command && !argv[i][1]) command = argv[i][0];
		else if (!files->name) {
			if (!(files->name = malloc(strlen(argv[i])+1))) error(2, NPPVSS);
			strcpy(files->name, argv[i]);
		} else {
			if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
			files = files->next;
			files->next = NULL;
			if (!(files->name = malloc(strlen(argv[i])+1))) error(2, NPPVSS);
			strcpy(files->name, argv[i]);
		}
	}

	scr_write = !strchr(switches, 's') + !!strchr(switches, 'z');
	printnf("\nAHC - Nstroj pro kompresi pomoc Adaptivnho Huffmanova kdu");
	if (strchr(switches, '?') || strchr(switches, 'h')) help(0);

	param.attrib = !!strchr(switches, 'a');
	param.absnames = !!strchr(switches, 'd');
	param.erase = !!strchr(switches, 'e');
	param.extract = (command == 'x');
	param.onlynames = !!strchr(switches, 'n');
	param.pathnames = !!strchr(switches, 'p');
	param.recurse = !!strchr(switches, 'r');
	param.std_in = !!strchr(switches, 'i');
	param.std_out = !!strchr(switches, 'o');
	param.sfx = !!strchr(switches, 'x');

	if (!command) {
		if (!(file = fopen(argv[0], "rb"))) error (1, "Nelze otevt spustiteln soubor");
		fseek(file, 0, SEEK_END);
		if (ftell(file) > (exesize = getexesize(file))) { //samorozbaliteln archiv
			printef("Samorozbaliteln archiv - zahjit rozbalovn? [A, N] ");
			if (scr_write && toupper(getch()) != 'A') { printef("Ne\n"); help(5); } else printef("Ano\n");
			archive = bfopen(file);
			fseek(archive->file, exesize, SEEK_SET);
			command = 'x';
			printnf(""); printaf("Otevrm", argv[0]);
		} else { //chybjc pkaz
			if (fclose(file)) error (1, "Nelze zavt spustiteln soubor");
			help(3);
		}
	}
	else if (command != 'a' && command != 'x' && command != 'l') error(3, "Neznm pkaz");
	else if (command == 'a' ? !param.std_out : !param.std_in) {
		strcpy(fname, firstfile->name);
		if (fname[0] && fname[0] != EXCLUDE_CHAR && !strchr(fname, '?') && !strchr(fname, '*') && fname[strlen(fname)-1] != PATH_DIVIDER) { //jmno prvnho souboru je jednoznan
			strcpy(archive_name, firstfile->name);
			if (firstfile->next) {
				files_temp = firstfile;
				firstfile = firstfile->next;
				free(files_temp);
			} else { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); }
		} else { //automatick uren jmna souboru (jmno prvnho souboru nen jednoznan)
			getcurdir(0, fname);
			if (fname[0]) //jestlie nejsem v koenovm adresi, je jmno souboru jmno aktulnho adrese
				if (str = strrchr(fname, PATH_DIVIDER)) strcpy(archive_name, str + 1);
				else strcpy(archive_name, fname);
			else {
				findfirst("*.*", &ffblk, FA_LABEL);
				if (ffblk.ff_name[0]) strcpy(archive_name, ffblk.ff_name);
				else strcpy(archive_name, "ahc");
			}
		}
		if (strrchr(archive_name, '.') <= strrchr(archive_name, PATH_DIVIDER)) strcat(archive_name, param.sfx ? ".exe" : ".ahc"); //u jmna archivu chyb koncovka
		strupr(archive_name);
		printnf(""); printaf(command == 'a' ? "Vytvm" : "Otevrm", archive_name);
		if (!(archive = bopen(archive_name, command == 'a' ? "wb" : "rb"))) error(1, "Nelze otevt archiv");
	}
	else {
		if (command == 'a') _streams[1] = *freopen("CON", "wb", stdout); else _streams[0] = *freopen("CON", "rb", stdin);
		if (!(archive = bfopen(command == 'a' ? stdout : stdin))) error(1, "Nelze otevt archiv");
	}

	if (command == 'a' && param.sfx) { //jestlie vytvm sfx, nejprve zkopruji exe soubor
		if (!(file = fopen(argv[0], "rb"))) error (1, "Nelze otevt spustiteln soubor");
		exesize = getexesize(file);
		for (a=0; a < exesize && (i = getc(file)) != EOF; a++) putc(i, archive->file);
		if (fclose(file)) error (1, "Nelze zavt spustiteln soubor");
	}

	if (!firstfile->name) { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); } //nezadal jsem dn jmno souboru
	else if (firstfile->name[0] == EXCLUDE_CHAR) { //jestlie je prvn soubor vyluovan, pedadm mu *.*
		files_temp = firstfile;
		if (!(firstfile = malloc(sizeof(FILES)))) error(2, NPPVSS);
		firstfile->next = files_temp;
		if (!(firstfile->name = malloc(4))) error(2, NPPVSS);
		strcpy(firstfile->name, "*.*");
	}

	if (strchr(switches, 'l')) { //pouvm seznam soubor
		for (files = firstfile; files; files=files->next) {
			done = findfirst(files->name, &ffblk, 0);
			free(files->name); files->name = NULL;
			while (!done) {
				if (!(file = fopen(ffblk.ff_name, "r"))) error(1, "Nelze otevt soubor se seznamem soubor");
				while (fgets(fname, MAX_FILENAME, file)) {
					fname[strlen(fname) - 1] = 0;
					if (files->name) {
						files_temp = files->next;
						if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
						files = files->next;
						files->next = files_temp;
					}
					if (!(files->name = malloc(strlen(fname)+1))) error(2, NPPVSS);
					strcpy(files->name, fname);
				}
				if (fclose(file)) error(1, "Nelze zavt soubor se seznamem soubor");
				done = findnext(&ffblk);
			}
		}
	}

	if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
	files = files->next; files->next = NULL;
	if (!(files->name = malloc(strlen(archive_name)+2))) error(2, NPPVSS);
	files->name[0] = EXCLUDE_CHAR; strcpy(files->name+1, archive_name); //na konec seznamu pidm !archiv

	if (strchr(switches, 'm') && command == 'x' && !param.std_out) { //chci vytvoit adres na rozbalovn
		if (str = strrchr(archive_name, PATH_DIVIDER)) strcpy(archive_name, str + 1);
		if (str = strrchr(archive_name, '.')) str[0] = 0;
		mkdir(archive_name); chdir(archive_name);
		if (!strchr(archive->name, ':') && archive->name[0] != PATH_DIVIDER) { //upraven cesty k souboru
			strcpy(fname, archive->name);
			strcpy(archive->name, ".."); archive->name[3] = 0; archive->name[2] = PATH_DIVIDER;
			strcat(archive->name, fname);
		}
	}

	if (param.extract || command == 'l') extract_files(archive, firstfile, param);
	else compress_files(archive, firstfile, param);
	return 0;
}
