#ifndef _BITIO_H
#define _BITIO_H

#include <stdio.h>

typedef struct {
	unsigned long data;
	int count;
} BITS;

typedef struct {
	FILE *file;
	char name[255];
	unsigned char buf; // obsah bufferu
	int n; // poet prvk v bufferu
} BITFILE;

#define _getb(bitfile) (!bitfile->n ? getbuf(bitfile) : 0, bitfile->n--, (bitfile->buf >> bitfile->n) & 1)

BITFILE *bfopen(FILE *file);
BITFILE *bopen(char *filename, char *mode);
int bclose(BITFILE *bitfile);

int getbuf(BITFILE *bitfile);
void putbuf(BITFILE *bitfile);
void clearbuf(BITFILE *bitfile);

int getb(BITFILE *bitfile);
unsigned long getbits(int count, BITFILE *bitfile);

void putb(int b, BITFILE *bitfile);
void putbits(unsigned long data, int count, BITFILE *bitfile);

#endif
